/**
 * generated by Xtext
 */
package org.eclipse.etrice.core.etphys.eTPhys;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.etrice.core.common.base.Documentation;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Node Ref</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * <br>This stands for a node instance in a specific role.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.etrice.core.etphys.eTPhys.NodeRef#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.etrice.core.etphys.eTPhys.NodeRef#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.etrice.core.etphys.eTPhys.NodeRef#getDocu <em>Docu</em>}</li>
 * </ul>
 *
 * @see org.eclipse.etrice.core.etphys.eTPhys.ETPhysPackage#getNodeRef()
 * @model
 * @generated
 */
public interface NodeRef extends EObject
{
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * <br>The name of the reference by which it is referred to in the model.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.etrice.core.etphys.eTPhys.ETPhysPackage#getNodeRef_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.etrice.core.etphys.eTPhys.NodeRef#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * <br>The node class of this reference.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Type</em>' reference.
	 * @see #setType(NodeClass)
	 * @see org.eclipse.etrice.core.etphys.eTPhys.ETPhysPackage#getNodeRef_Type()
	 * @model
	 * @generated
	 */
	NodeClass getType();

	/**
	 * Sets the value of the '{@link org.eclipse.etrice.core.etphys.eTPhys.NodeRef#getType <em>Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' reference.
	 * @see #getType()
	 * @generated
	 */
	void setType(NodeClass value);

	/**
	 * Returns the value of the '<em><b>Docu</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * <br>This is an optional documentation.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Docu</em>' containment reference.
	 * @see #setDocu(Documentation)
	 * @see org.eclipse.etrice.core.etphys.eTPhys.ETPhysPackage#getNodeRef_Docu()
	 * @model containment="true"
	 * @generated
	 */
	Documentation getDocu();

	/**
	 * Sets the value of the '{@link org.eclipse.etrice.core.etphys.eTPhys.NodeRef#getDocu <em>Docu</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Docu</em>' containment reference.
	 * @see #getDocu()
	 * @generated
	 */
	void setDocu(Documentation value);

} // NodeRef
